library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity sim is
end sim;

architecture RTL of sim is

  attribute mark_debug : string;
  attribute keep : string;
  attribute S : string;

  component uplport
    port (
      UPLGlobalClk : in std_logic;
      UPLReset : in std_logic;
      ready : out std_logic;
      done : in std_logic;
      send_length : in signed(32-1 downto 0);
      recv_length : out signed(32-1 downto 0);
      data_length : out signed(32-1 downto 0);
      data_address : in signed(32-1 downto 0);
      data_dout : out signed(32-1 downto 0);
      data_din : in signed(32-1 downto 0);
      data_we : in std_logic;
      data_oe : in std_logic;
      UPLIn_Data : in std_logic_vector(32-1 downto 0);
      UPLIn_En : in std_logic;
      UPLIn_Request : in std_logic;
      UPLIn_Ack : out std_logic;
      UPLOut_Data : out std_logic_vector(32-1 downto 0);
      UPLOut_En : out std_logic;
      UPLOut_Request : out std_logic;
      UPLOut_Ack : in std_logic
    );
  end component uplport;


  signal clk : std_logic := '0';
  signal reset : std_logic := '0';
  signal counter : signed(32-1 downto 0) := (others => '0');
  type Type_main is (
    main_IDLE,
    main_S0  
  );
  signal main : Type_main := main_IDLE;
  signal main_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0001 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0002 : std_logic := '0';
  signal tmp_0003 : std_logic := '0';
  signal tmp_0004 : std_logic := '0';
  signal tmp_0005 : std_logic := '0';
  signal U_UPLGlobalClk : std_logic := '0';
  signal U_UPLReset : std_logic := '0';
  signal U_ready : std_logic := '0';
  signal U_done : std_logic := '0';
  signal U_send_length : signed(32-1 downto 0) := (others => '0');
  signal U_recv_length : signed(32-1 downto 0) := (others => '0');
  signal U_data_length : signed(32-1 downto 0) := (others => '0');
  signal U_data_address : signed(32-1 downto 0) := (others => '0');
  signal U_data_dout : signed(32-1 downto 0) := (others => '0');
  signal U_data_din : signed(32-1 downto 0) := (others => '0');
  signal U_data_we : std_logic := '0';
  signal U_data_oe : std_logic := '0';
  signal U_UPLIn_Data : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_UPLIn_En : std_logic := '0';
  signal U_UPLIn_Request : std_logic := '0';
  signal U_UPLIn_Ack : std_logic := '0';
  signal U_UPLOut_Data : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_UPLOut_En : std_logic := '0';
  signal U_UPLOut_Request : std_logic := '0';
  signal U_UPLOut_Ack : std_logic := '0';
  signal in_period : signed(32-1 downto 0) := (others => '0');
  signal tmp_0006 : std_logic := '0';
  signal tmp_0007 : std_logic := '0';
  signal tmp_0008 : std_logic := '0';
  signal tmp_0009 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0010 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0011 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0012 : std_logic := '0';
  signal tmp_0013 : std_logic := '0';
  signal op_ready_d : std_logic := '0';
  signal op_pulse : std_logic := '0';
  signal op_pulse_d : std_logic := '0';
  signal op_period : signed(32-1 downto 0) := (others => '0');
  signal tmp_0014 : std_logic := '0';
  signal tmp_0015 : std_logic := '0';
  signal tmp_0016 : std_logic := '0';
  signal tmp_0017 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0018 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0019 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0020 : std_logic := '0';
  signal tmp_0021 : std_logic := '0';
  signal tmp_0022 : std_logic := '0';

begin


  -- expressions
  tmp_0001 <= counter + 1;
  tmp_0002 <= '1' when counter >= 0 else '0';
  tmp_0003 <= '1' when counter <= 8 else '0';
  tmp_0004 <= tmp_0002 and tmp_0003;
  tmp_0005 <= '1' when tmp_0004 = '1' else '0';
  tmp_0006 <= '1' when in_period = 0 else '0';
  tmp_0007 <= U_UPLIn_Ack and tmp_0006;
  tmp_0008 <= '1' when in_period > 0 else '0';
  tmp_0009 <= in_period - 1;
  tmp_0010 <= tmp_0009 when tmp_0008 = '1' else (others => '0');
  tmp_0011 <= X"0000000a" when tmp_0007 = '1' else tmp_0010;
  tmp_0012 <= '1' when in_period > 0 else '0';
  tmp_0013 <= '1' when tmp_0012 = '1' else '0';
  tmp_0014 <= '1' when op_period = 0 else '0';
  tmp_0015 <= U_ready and tmp_0014;
  tmp_0016 <= '1' when op_period > 0 else '0';
  tmp_0017 <= op_period - 1;
  tmp_0018 <= tmp_0017 when tmp_0016 = '1' else (others => '0');
  tmp_0019 <= X"00000014" when tmp_0015 = '1' else tmp_0018;
  tmp_0020 <= '1' when op_period > 0 else '0';
  tmp_0021 <= not op_pulse;
  tmp_0022 <= tmp_0021 and op_pulse_d;

  -- sequencers
  process
  begin
    -- state main = main_IDLE
    main <= main_S0;
    wait for 10 ns;
    -- state main = main_S0
    main <= main_IDLE;
    wait for 10 ns;
  end process;


  process(main)
  begin
    if main = main_IDLE then
      clk <= '0';
    elsif main = main_S0 then
      clk <= '1';
    end if;
  end process;

  process(main)
  begin
    if main = main_IDLE then
      reset <= tmp_0005;
    end if;
  end process;

  process(main)
  begin
    if main = main_S0 then
      counter <= tmp_0001;
    end if;
  end process;

  U_UPLGlobalClk <= clk;

  U_UPLReset <= reset;

  process(main)
  begin
    if main = main_IDLE then
      U_done <= tmp_0022;
    end if;
  end process;

  U_send_length <= X"00000010";

  process(main)
  begin
    if main = main_IDLE then
      U_UPLIn_En <= tmp_0013;
    end if;
  end process;

  U_UPLOut_Ack <= '1';

  process(main)
  begin
    if main = main_IDLE then
      in_period <= tmp_0011;
    end if;
  end process;

  process(main)
  begin
    if main = main_IDLE then
      op_ready_d <= U_ready;
    end if;
  end process;

  process(main)
  begin
    if main = main_IDLE then
      op_pulse <= tmp_0020;
    end if;
  end process;

  process(main)
  begin
    if main = main_IDLE then
      op_pulse_d <= op_pulse;
    end if;
  end process;

  process(main)
  begin
    if main = main_IDLE then
      op_period <= tmp_0019;
    end if;
  end process;


  inst_U : uplport
  port map(
    UPLGlobalClk => clk,
    UPLReset => reset,
    ready => U_ready,
    done => U_done,
    send_length => U_send_length,
    recv_length => U_recv_length,
    data_length => U_data_length,
    data_address => U_data_address,
    data_dout => U_data_dout,
    data_din => U_data_din,
    data_we => U_data_we,
    data_oe => U_data_oe,
    UPLIn_Data => U_UPLIn_Data,
    UPLIn_En => U_UPLIn_En,
    UPLIn_Request => U_UPLIn_Request,
    UPLIn_Ack => U_UPLIn_Ack,
    UPLOut_Data => U_UPLOut_Data,
    UPLOut_En => U_UPLOut_En,
    UPLOut_Request => U_UPLOut_Request,
    UPLOut_Ack => U_UPLOut_Ack
  );


end RTL;
